#ifndef __ataPassThroughIOCTL_h
#define __ataPassThroughIOCTL_h

#include <winioctl.h>

// so structs are correctly aligned and stuff
#pragma pack(1)

#define IOCTL_SCSI_BASE FILE_DEVICE_CONTROLLER
#define IOCTL_IDE_PASS_THROUGH CTL_CODE(IOCTL_SCSI_BASE, 0x040a, METHOD_BUFFERED, FILE_READ_ACCESS | FILE_WRITE_ACCESS)

typedef struct {
	UCHAR bFeaturesReg;
	UCHAR bSectorCountReg;
	UCHAR bSectorNumberReg;
	UCHAR bCylLowReg;
	UCHAR bCylHighReg;
	UCHAR bDriveHeadReg;
	UCHAR bCommandReg;
	UCHAR bReserved;
} NIDEREGS, *PNIDEREGS;

typedef struct
{
	NIDEREGS IdeReg;
	ULONG   DataBufferSize;
	UCHAR   DataBuffer[1];
} ATA_PASS_THROUGH;


/*
Byte 	Input Register
0 	Features register
1 	Sector count register
2 	Sector number tegister
3 	Cylinder low register
4 	Cylinder high register
5 	Device/head register
6 	Command register
7 	Reserved


Byte 	Output Register
0 	Error register
1 	Sector count register
2 	Sector number register
3 	Cylinder low register
4 	Cylinder high register
5 	Device/head register
6 	Status register
7 	Reserved

*/

#pragma pack()

#endif